/*
gui-js/menu.js
This file is distributed under terms of the Affero GPL v3 license or later, see http://yasep.org
created mar. août 30 02:24:47 CEST 2011 by whygee@f-cpu.org
version lun. sept 12 08:17:07 CEST 2011 init_obj() added

This file implements a menu bar that can be independent from ygwm.
  some features depend on winman and avoid closure.
*/


init_obj.push(menu={
  list:{},

  unfold_menuItem: function(){
    if (ygwm && (ygwm.moved_div != null))
      return; // No display if ygwm is currently moving a window
    if (this.listlength > 0)
      this.menuItemList.style.display=""; // display only if something to show
  },

  fold_menuItem: function(){
    this.menuItemList.style.display="none";
  },

  onClick: function(){
    winman.activate_window(this.key);
  },

  // "name" can be HTML to make links and pictures and stuff
  // func can be a key string
  subMenuItem: function(n,name,func){
    if (n.list[name])
      return n.list[name]; // don't create duplicates
    var o=document.createElement("DIV");
    o.className="menuItem";
    o.innerHTML=name;
    if (typeof func === 'function')
      o.onclick=func;
    else {
      if (typeof func === 'string') {
        o.onclick=menu.onClick;
        o.key=func; // avoid closure
      }
    }
    n.list[name]=o;
    n.listlength++;
    n.menuItemList.appendChild(o);
    return o;
  },

  mainMenuItem: function(name,dir){
    if (menu.list[name])
      return menu.list[name];

    var n=document.createElement("DIV");
    if (dir != "R")
      dir="L"; // class "L" by default (left-justified unless told otherwise)
    n.className="menuBarItem"+dir;

    n.innerHTML="<span>"+name+"</span>";
    n.list={};
    n.listlength=0;
    n.onmouseout =menu.fold_menuItem;
    n.onmouseover=menu.unfold_menuItem;
    menu.list[name]=n;
    menu.mainMenu_id.appendChild(n);
    n.style.width=n.scrollWidth+'px'; // sets the size once and for all

    // create the folding list
    n.menuItemList=document.createElement("DIV");
    n.menuItemList.className="menuItemList";
    n.menuItemList.style.display="none";
    n.appendChild(n.menuItemList);

    return n;
  },

  // the argument list is used to make a first layout
  // to organise the menu, before individual items are created, out of order.
  create: function(){
    if (document.getElementById("MainMenuBar"))
      return alert("menus already created");

    var t, dir="L";
    menu.mainMenu_id=document.createElement("DIV");
    menu.mainMenu_id.id="MainMenuBar";
    document.body.appendChild(menu.mainMenu_id);

    for (var i=0; i < arguments.length; i++) {
      t=arguments[i];
      if (typeof t == "string") {
        if (t=="") // separator
          dir="R";
        else
          menu.mainMenuItem(arguments[i],dir);
      }
    }
  },


/////////////////////////////// YASEP-SPECIFIC ///////////////////////////////

  rainbow_x:5,
  rainbow_i:0,
  key_count:0,

  iterate_rainbow:function(){ /* create a "rainbow" */
    var j=YGCSS.ColorStylesNames[--menu.rainbow_i];
    ygwm.new_window(j, null, "none", 160,90, menu.rainbow_x,
      Math.ceil((menu.rainbow_x/2)+60), false, true, true, true, false, j);
    menu.rainbow_x+=40;
    if (menu.rainbow_i>0)
      setTimeout(menu.iterate_rainbow,1);
  },

  iterate_keys:function(){
    winman.activate_window(winman.keys_list[--menu.key_count]);
    if (menu.key_count>0)
      setTimeout(menu.iterate_keys,1);
  },

  // Build a YASEP-specific menu :
  init_obj: function(){
    menu.create("Tools", "Doc", "Web",  ""/*separation*/,
      "windows", "LNG"); // reverse order for the elements on the right side
    var j=menu.mainMenuItem("windows","R");
      menu.subMenuItem(j,"Welcome&nbsp;!", "welcome");
      menu.subMenuItem(j,"Hide&nbsp;all",winlist.minimizeAll);
      menu.subMenuItem(j,"Show&nbsp;all",winlist.restoreAll);
      menu.subMenuItem(j,"Rainbow!", function(){
         menu.rainbow_i=YGCSS.ColorStylesNames.length;
         menu.iterate_rainbow();
      });
      menu.subMenuItem(j,"All&nbsp;windows", function() {  /* create a "rainbow" */
        menu.key_count=winman.keys_list.length;
        menu.iterate_keys();
      });
      menu.subMenuItem(j,'<a target="_blank" href="gui-js/ygwm.html">YGWM&nbsp;demo</a>');

    var j=menu.mainMenuItem("Web");
      menu.subMenuItem(j,'<a target="_blank" href="yasep.tgz">Download</a>');
      menu.subMenuItem(j,'<a target="_blank" href="http://yasep.org">yasep.org</a>');
      menu.subMenuItem(j,'<a target="_blank" href="http://news.yasep.org/">blog</a>');
      menu.subMenuItem(j,'<a target="_blank" href="https://www.facebook.com/pages/The-YASEP/167478153314916">facebook</a>');
  }
});
