/*
  yasep/gui-js/minimize.js
  This file is distributed under terms of the Affero GPL v3 license or later, see http://yasep.org
  created mar. oct. 18 13:24:47 CEST 2011 by whygee@f-cpu.org

  potential bug : "function" appears 2x in ParsedWordsArray
*/

JSkeyWords="abstract break boolean byte char class case catch class const continue"
 +" debugger default delete do double else enum export extends"
 +" final finally float for function goto if implements import in instanceof"
 +" int interface import let long native new package private protected"
 +" public return short static super switch synchronized this throw throws transient try"
 +" typeof undefined var void volatile while with yield";

JSbaseObjects="arguments Array Error Function Number Date Function document Math String window RegExp XMLHttpRequest console";
Redifinable="true false null Date Function document Math String window RegExp XMLHttpRequest alert console";

JS_Methods = "childNodes firstChild lastChild previousSibling nextSibling parentNode id className"
 +" getElementById getElementsByTagName removeChild replaceChild replaceData"
 +" cloneNode insertBefore appendChild appendData deleteData insertData"
 +" nodeName nodeType nodeValue innerHTML setAttribute setAttributeNode"
 +" onclick onmouseup onmousemove onmousedown onmouseover event left top scrollTop"
 +" style body cursor display apply call prototype self locationtop zIndex scrollLeft"
 +" clearTimeout setTimeout src length Object indexOf height width backgroundColor"
 +" scrollBy scrollTo scrollHeight scrollWidth createElement replace target slice sort"
 +" join split floor random cookie responseText documentElement pageX pageY clientX clientY"
 +" title ceil charAt unescape getTime toGMTString location open send substring srcElement"
 +" href onresize clientWidth clientHeight close styleSheets info charCodeAt"
 +" offsetLeft offsetTop push pop onchange onload";

CustomBlackList="";
/*"FORM_ALONE FORM_R FORM_RR FORM_i FORM_iR FORM_Ri"
 +" FORM_IRR FORM_IR FORM_RI FORM_RRR FORM_iRR SWAP_IR ALIAS_RR"
 +" ALIAS_IRR NO_CONDITION IMM16_5LSB IMM16_8LSB OPTIONAL YASEP16_ONLY"
 +" YASEP32_ONLY IgnoreImmSign NO_WRITEBACK ABORT_WRITE CHANGE_CARRY"
 +" IGNORE_SND IGNORE_SI4 IGNORE_IMM16 IMM20 Preliminary GROUP_CTL"
 +" GROUP_SMT GROUP_IE GROUP_SHL GROUP_ROP2 GROUP_ASU GROUP_MUL"
 +" GROUP_RSV ALWAYS NEVER ZERO NZ LSB0 EVEN LSB1 ODD MSB0 POSITIVE"
 +" MSB1 NEGATIVE NO_CARRY NO_BORROW CARRY BORROW hex_form asm_form"
 +" value_asm value_hex value action";
*/

JSminimize=function(src, bl){
  var EOF=0, SPACE=1, WORD=2, STRING=3, PUNCT=4,
      CURLY=5, SEMICOLON=6, REGEXP=7, KEYWORD=8,
      COLON=9, INTERNAL=10, EXTERNAL=11, EMPTY=12,
    TYPE=EOF, // type of the returned token;
    token='',i, t, u, v, src_index=0, l=src.length,
    newname, newname_l, substLUT=[],substArray=[], pre="",
  dst=[], dst_type=[];

  for (var i=0; i<4; i++) {  // prevent index errors when looking back
    dst.push("");
    dst_type.push(EOF);
  }

  function string2LUT(str){
    var a=[], b=str.split(" "), c;
    for (i in b) {
      c=b[i];
      if (c != "")
        a['P'+c]=i;
    }
    return a;
  }

  var JSkeyWords_LUT     =string2LUT(JSkeyWords),
      JSbaseObjects_LUT  =string2LUT(JSbaseObjects),
      JS_Methods_LUT     =string2LUT(JS_Methods),
      CustomBlackListLUT =string2LUT(CustomBlackList+" "+JSkeyWords+" "+JSbaseObjects+" "+JS_Methods+" "+DynamicBlackListWords),
      ParsedWordsLUT=[],  // LUT
      ParsedWordsArray=[], // integer-addressed
      DynamicBlackListWordsLUT= string2LUT(DynamicBlackListWords),
      RedifinableLUT= string2LUT(Redifinable),

      debug=l*3, w="",

      variableChar=[],
      variableCharStrings="#0123456789_$abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ";
  for (t in variableCharStrings)
    variableChar[variableCharStrings[t]]=t; // dummy value;

  var VarCharIndex=[];

  function newVarName() {
    var v, i;
    do {
      // incrémente les compteurs en propageant la retenue
      i=0;
      do {
        if (i>= VarCharIndex.length) // s'il n'existe pas,
          VarCharIndex[i]=10; // crée un nouveau chiffre à "_"

        VarCharIndex[i]++;
        if (VarCharIndex[i] < variableCharStrings.length)
          break; // arrête si aucune retenue à propager.

        VarCharIndex[i++]=1; // skip "#"
      } while (true);

      // concatène les chiffres dans v dans l'ordre décroissant
      v="";
      for (i in VarCharIndex)
        v=variableCharStrings[VarCharIndex[i]]+v;

      if (CustomBlackListLUT['P'+v])
        w+=v+" dans CustomBlackListLUT\n";

      if (ParsedWordsLUT['P'+v])
        w+=v+" dans ParsedWords x"+ParsedWordsArray[ParsedWordsLUT['P'+v]].count+"\n";

    } while (CustomBlackListLUT['P'+v] || ParsedWordsLUT['P'+v]);
    return v
  }


  /////////// get a new char ///////////
////  function getChar() {
////    if (src_index>=l)
////      return null;
////    return src[src_index++];
////  }

  /////////// Tokenizer ///////////
  function getToken() {
////    var t=getChar(); // get a first char
    if (src_index>=l)
      return EOF;
    t=src[src_index++];
    token=t;

    switch(t){
////      case null: token=""; return EOF;
      case '}' : return CURLY;
      case ':' : return COLON;
      case ';' : return SEMICOLON;

      case ' ' :
      case '\t':
      case '\r':
      case '\n': token=' ';
        do {
////          t=getChar();
          if (src_index>=l)
            return EOF;
          t=src[src_index++];
        } while ((t==' ')||(t=='\r')||(t=='\n')||(t=='\t'));
////        if (t==null)
////          return EOF; // don't decrement !
        src_index--; // return the unwanted char
        return SPACE;

      case "'":
      case '"':
        do {
////          u=getChar();
////          if (u==null) {
////            alert("unfinished string"); return EOF }
          if (src_index>=l){
            alert("unfinished string");
            return EOF;
          }
          u=src[src_index++];

           // escape code :
          if (u=='\\') {
////            v=getChar();
////            if (v==null) {
////              alert("unfinished string"); return EOF }
            if (src_index>=l){
              alert("unfinished string"); 
              return EOF;
            }
            token+=u+src[src_index++];
          }
          else
            token+=u;
        } while (t!=u);
        return STRING;

      case '/':
////        u=getChar();
        if (src_index>=l)
          return PUNCT;
        u=src[src_index++];

        switch(u) {
          case '/': // single-line comment
            do {
////              u=getChar();
              if (src_index>=l)
                return EOF;
              u=src[src_index++];
            } while (u!='\n');
////            } while ((u!='\n')&&(u != null));
            return EMPTY; 

          case '*':
            while(true) {
////              u=getChar();
              if (src_index>=l){
                alert("unfinished comment");
                return EOF;
              }
              u=src[src_index++];

              if (u=="*"){ // need a second character to decide if we close the comment
////                u=getChar();
                if (src_index>=l){
                  alert("unfinished comment");
                  return EOF;
                }
                if (src[src_index++]=="/")
////                if (u=="/")
                  return EMPTY;
              }
            } //// while (u != null);
////            alert("unfinished comment");
////            return EOF;

          default: // is it a regexp ? get the preceding char
            if ((src_index > 3) && (src[src_index-3]=='(')) {
              token+=u;

              do {
////                u=getChar();
                if (src_index>=l){
                  alert("unfinished regex"); return EOF }
                u=src[src_index++];

////                if (u==null) {
////                  alert("unfinished regex"); return EOF }

                 // escape code :
                if (u=='\\') {
////                  v=getChar();
////                  if (v==null) {
////                    alert("unfinished regex"); return EOF }
////                  token+=u+v;
                  if (src_index>=l){
                    alert("unfinished regex"); return EOF }
                  token+=u+src[src_index++];
                }
                else
                  token+=u;
              } while (u!='/');
              return REGEXP;
            }

            // Just a normal "/"
////            if (u!=null)
              src_index--;
            return PUNCT;
        }

      default:
        if (variableChar[t]) {
          do { // a "word"

////            t=getChar();
            if (src_index>=l)
              return WORD;
            else t=src[src_index++];

            if (variableChar[t])
              token+=t;
            else {
              // blackList("name");  => disappears
              if (token=="blackList") {
                token=' ';
                while(t!=';') {
////                while((t!=';')&&(t!=null))
////                  t=getChar();
                  if (src_index>=l)
                    return EMPTY;
                  else t=src[src_index++];
                }
                return EMPTY;
              }

////              if (t!=null)
              src_index--;

              if (JSkeyWords_LUT['P'+token])
                return KEYWORD;

              // property of an external object ?
              if (JS_Methods_LUT['P'+token])
                return EXTERNAL;

              return WORD;
            }
          } while (true);
        }

        // all the other chars
        return PUNCT;
    }
  }


  /////////// SUBSTITUTE ///////////

  function substitute(){
    u="";
    v="";
    i=0;
    newname=newVarName(); newname_l=newname.length;
    var ParsedWordsArray2 = ParsedWordsArray; // copy
    ParsedWordsArray2.sort(function(a, b) { return b.count - a.count; });

    while (( i < ParsedWordsArray2.length) && (ParsedWordsArray2[i].count > 1)) {
      var t=ParsedWordsArray2[i];
      if ( t.name.length > newname_l ) {

        // numbers: make sure it's worth it
        if (RedifinableLUT['P'+t.name] || ((t.name[0]>='0')&&(t.name[0]<='9')) ) {
          if ((t.name.length * t.count) > ((t.count*newname_l) +t.name.length+2+newname_l)) {
            pre+=newname+"="+t.name+";"
              if (bl=="report") pre+="\n";
            // same code as last case
            substLUT['P'+t.name]=newname;
            substArray.push({count:t.count,name:t.name,subst:newname});
            u+=newname+ " : " + t.count+" "+ t.name+"\n";
            newname=newVarName(); newname_l=newname.length;
          }
          else
            w+="trop petit: "+t.name+" x "+t.count+"\n";
        } else {
          if (CustomBlackListLUT['P'+t.name]) { // blacklisted : don't substitute
            w+="Blacklist : " + t.count+" x "+ t.name+"\n";
          }
          else { // substitute directly
            substLUT['P'+t.name]=newname;
            substArray.push({count:t.count,name:t.name,subst:newname});
            u+=newname+ " : " + t.count+" "+ t.name+"\n";
            newname=newVarName(); newname_l=newname.length;
          }
        }
      }
      i++;
    }

    if (bl=="report")
      return pre+"\n\n"+ u + "\n\n" + w + "\n\n" + DynamicBlackListWords;

    // else
    for (i in dst)
      if ((dst_type[i]==WORD) && substLUT['P'+dst[i]])
        dst[i]=substLUT['P'+dst[i]];
    return pre +  dst.join("");
 }

  /////////// BODY/FSM ///////////

  do {
    TYPE=getToken();
          if (0>debug--) { alert("loop stuck in main"); return dst};

    if (TYPE==EMPTY)
      continue;

    // remove the space unless there was a word and we get a new word
    if ((dst_type[dst.length-1] == SPACE)
      && ((TYPE!=WORD) || (dst_type[dst.length-2]!=WORD))) {
        dst.pop();
        dst_type.pop();
    }

    switch(TYPE){
      case EOF:
        if (bl=="noSubst")
          return dst.join("");
        return substitute();

      case STRING:
        // merge "string1"+"string2" into "string1string2"
        if ((dst[dst.length-1] == "+") 
         && (dst_type[dst.length-2] == STRING)
         && (token[0]==dst[dst.length-2][0])) {
          dst[dst.length-2] =
              dst[dst.length-2].slice(0,-1)  // remove the last char
            + token.slice(1);  // remove the first char

          dst.pop(); // remove the "+"
          dst_type.pop();
          break; // don't push token into dst
        }
        // "else" is implicit, fold to default push
        dst.push(token);
        dst_type.push(TYPE); break;

      case COLON:
        // si précédé d'un mot et un signe, alors ce mot est une déclaration
        dst.push(token);
        dst_type.push(TYPE); break;

      case WORD :
        // property of an external object ?
        if ((dst[dst.length-1]=='.') && (dst_type[dst.length-2]==EXTERNAL)) {
          JS_Methods_LUT['P'+token]=42;
          pre+="Adding method "+token;          
          dst.push(token);
          dst_type.push(EXTERNAL); break;
        }

        // a "normal" word
        if (ParsedWordsLUT['P'+token]) {
          ParsedWordsArray[ParsedWordsLUT['P'+token]].count++;
        }
        else {
          // add the new word to the list
          ParsedWordsLUT['P'+token]=ParsedWordsArray.length;
          ParsedWordsArray.push({count:1, name:token});
        }
        dst.push(token);
        dst_type.push(TYPE); break;

      case KEYWORD:
      case REGEXP:
      case SPACE:
      case PUNCT:
                  dst.push(token);
                  dst_type.push(TYPE); break;

      case CURLY:
        if (dst_type[dst.length-1] == SEMICOLON) {
          dst.pop(); // remove the ";"
          dst_type.pop();
        }
        dst.push(token);
        dst_type.push(TYPE); break;

      case SEMICOLON:
        if (dst_type[dst.length-1] == SEMICOLON)
          break; // avoids multiple semicolons
        dst.push(token);
        dst_type.push(TYPE);
//                  dst.push("\n");
//                  dst_type.push(PUNCT);
        break;


      default: alert("unknown token type");
        return "Error "+TYPE+" at index " + src_index+ " with word "+ token+ " "+ dst.join("");
    }
  } while (true);
}
